C# 並行和多線程編程——Task進階知識

 一、Task的嵌套

   Task中還可以再嵌套Task,Thread中能不能這樣做,我隻能說我是沒這樣寫過。Task中的嵌套,我感覺其實也可以分開來寫,不過嵌套起來會方便管理一點。Task中的嵌套分為兩種,關聯嵌套和非關聯嵌套,就是說內層的Task和外層的Task是否有聯系,下面我們編寫代碼先來看一下非關聯嵌套,及內層Task和外層Task沒有任何關系,還是在控制臺程序下面,代碼如下:

static void Main(string[] args)
   {
     var pTask = Task.Factory.StartNew(() => 
     {
      var cTask = Task.Factory.StartNew(() =>
      {
        System.Threading.Thread.Sleep(2000);
        Console.WriteLine("Childen task finished!");
      });
      Console.WriteLine("Parent task finished!");
     });
     pTask.Wait();
     Console.WriteLine("Flag");
     Console.Read();
   }

運行後,輸出以下信息:

從圖中我們可以看到,外層的pTask運行完後,並不會等待內層的cTask,直接向下走先輸出瞭Flag。這種嵌套有時候相當於我們創建兩個Task,但是嵌套在一起的話,在Task比較多時會方便查找和管理,並且還可以在一個Task中途加入多個Task,讓進度並行前進。

下面我們來看一下如何創建關聯嵌套,就是創建有父子關系的Task,修改上面代碼如下:

static void Main(string[] args)
   {
     var pTask = Task.Factory.StartNew(() => 
     {
      var cTask = Task.Factory.StartNew(() =>
      {
        System.Threading.Thread.Sleep(2000);
        Console.WriteLine("Childen task finished!");
      },TaskCreationOptions.AttachedToParent);
      Console.WriteLine("Parent task finished!");
     });
     pTask.Wait();
     Console.WriteLine("Flag");
     Console.Read();
   }

可以看到,我們在創建cTask時,加入瞭以參數,TaskCreationOptions.AttachedToParent,這個時候,cTask和pTask就會建立關聯,cTask就會成為pTask的一部分,運行代碼,看下結果:

可以看到,tTask會等待cTask執行完成。省得我們寫Task.WaitAll瞭,外層的Task會自動等待所有的子Task完成才向下走。

下面我們來寫一個Task綜合使用的例子,來看一下多任務是如何協作的。假設有如下任務,如圖:

任務2和任務3要等待任務1完成後,取得任務1的結果,然後開始執行。任務4要等待任務2完成,取得其結果才能執行,最終任務3和任務4都完成瞭,合並結果,任務完成。圖中已經說的很明白瞭。下面來看一下代碼:

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TaskDemo
{
  class Program
  {
    static void Main(string[] args)
    {
      Task.Factory.StartNew(() =>
      {
        var t1 = Task.Factory.StartNew<int>(() => 
        {
          Console.WriteLine("Task 1 running...");
          return 1;
        });
        t1.Wait(); //等待任務一完成
        var t3 = Task.Factory.StartNew<int>(() =>
        {
          Console.WriteLine("Task 3 running...");
          return t1.Result + 3;
        });
        var t4 = Task.Factory.StartNew<int>(() =>
        {
          Console.WriteLine("Task 2 running...");
          return t1.Result + 2;
        }).ContinueWith<int>(task =>
        {
          Console.WriteLine("Task 4 running...");
          return task.Result + 4;
        });
        Task.WaitAll(t3, t4); //等待任務三和任務四完成
        var result = Task.Factory.StartNew(() =>
        {
          Console.WriteLine("Task Finished! The result is {0}",t3.Result + t4.Result);
        });
      });
      Console.Read();
    }
  }
}

任務2和任務4可以用ContinueWith連接執行,最終運行結果如圖:

可以看到所有的任務都執行瞭,我們也得到瞭正確的結果11.這下體會到Task的強大瞭吧~

 二、Task的異常處理

   任何應用程序都需要有異常處理機制,誰也不能保證自己寫到代碼在任何時候都是可以正常運行的,那麼在Task中到底該怎麼處理異常呢?先來按照平時的寫法,加個Try…Catch…試試,看看會出現什麼現象:

static void Main(string[] args)
   {
     try
     {
      var pTask = Task.Factory.StartNew(() =>
      {
        var cTask = Task.Factory.StartNew(() =>
        {
         System.Threading.Thread.Sleep(2000);
         throw new Exception("cTask Error!");
         Console.WriteLine("Childen task finished!");
        });
        throw new Exception("pTask Error!");
        Console.WriteLine("Parent task finished!");
      });

      pTask.Wait();
     }
     catch (Exception ex)
     {
      Console.WriteLine(ex.Message);
     }
     Console.WriteLine("Flag");
     Console.Read();
   }

大傢都看得懂,就不解釋瞭,直接F5運行,結果如圖:

唉,不對啊~~怎麼顯示這異常信息呢?先不說異常信息對不對,反正異常是捕獲到瞭。從這張圖中你們還發現瞭什麼嗎?

沒錯,cTask被中斷瞭,這裡cTask和pTask並沒有建立關聯,但是pTask出現異常,其內部的Task也都會中斷,不再執行,即使異常是在子Task啟動以後發生的。

下面我們繼續來說異常吧,來看看正確的異常處理辦法,怎麼捕獲到真正的異常信息,代碼如下:

static void Main(string[] args)
   {
     try
     {
      var pTask = Task.Factory.StartNew(() =>
      {
        var cTask = Task.Factory.StartNew(() =>
        {
         System.Threading.Thread.Sleep(2000);
         throw new Exception("cTask Error!");
         Console.WriteLine("Childen task finished!");
        });
        throw new Exception("pTask Error!");
        Console.WriteLine("Parent task finished!");
      });

      pTask.Wait();
     }
     catch (AggregateException ex)
     {
      foreach (Exception inner in ex.InnerExceptions)
      {
        Console.WriteLine(inner.Message);
      }
     }
     Console.WriteLine("Flag");
     Console.Read();
   }

這裡用瞭AggregateException,就是異常集合,當然開發中不會隻有一個線程,肯定會有多個線程,多個線程就可能有多個異常。我們變量異常集合,輸出異常信息,如下圖:

對瞭吧,看到正確的異常信息瞭,但是還是看不到cTask的,因為他被中斷瞭。

當然,除瞭在task中使用異常,我們還可以通過Task的幾個屬性來判斷Task的狀態,如:IsCompleted, IsFaulted, IsCancelled,Exception等等來判斷task是否成功的執行瞭。

 作者:雲霏霏

 博客地址:http://www.cnblogs.com/yunfeifei/

以上就是C# 並行和多線程編程——Task進階知識的詳細內容,更多關於C# 並行和多線程編程的資料請關註WalkonNet其它相關文章!